'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var url = _interopDefault(require('url'));
var got = _interopDefault(require('got'));

// and fields in GeoJSON format.

const DEFAULT_PARAMS = {
  f: 'geojson',
  where: '1=1',
  outFields: '*' // ArcGIS feature type name.

};
const FEATURE_TYPE = 'ArcGisFeature';
const sourceNodes = async (gatsbyContext, pluginOptions) => {
  var _response$body, _response$body$featur, _response$body$featur2;

  const {
    actions,
    createNodeId,
    createContentDigest
  } = gatsbyContext;
  const {
    createTypes,
    createNode
  } = actions;
  const {
    name,
    url: serverURL,
    params
  } = pluginOptions;
  const resolvedURL = url.resolve(serverURL, '0/query');
  const response = await got(resolvedURL, {
    json: true,
    query: { ...DEFAULT_PARAMS,
      ...params
    }
  }); // Set the geometry field as JSON. This field may have a different shape per
  // feature and will likely not need direct access to child properties via
  // GraphQL.

  createTypes(`
    type ${FEATURE_TYPE} implements Node {
      geometry: JSON!
    }
  `); // Create ArcGisFeature nodes for each feature.

  response === null || response === void 0 ? void 0 : (_response$body = response.body) === null || _response$body === void 0 ? void 0 : (_response$body$featur = _response$body.features) === null || _response$body$featur === void 0 ? void 0 : (_response$body$featur2 = _response$body$featur.forEach) === null || _response$body$featur2 === void 0 ? void 0 : _response$body$featur2.call(_response$body$featur, feature => createNode({ ...feature,
    id: createNodeId([name, feature === null || feature === void 0 ? void 0 : feature.id].filter(Boolean).join(' ')),
    featureId: feature === null || feature === void 0 ? void 0 : feature.id,
    sourceName: name,
    internal: {
      type: FEATURE_TYPE,
      contentDigest: createContentDigest(feature)
    }
  }));
};

exports.sourceNodes = sourceNodes;
//# sourceMappingURL=gatsby-node.js.map
